---
title: 'AudioScheduledSourceNode: ended event'
slug: Web/API/AudioScheduledSourceNode/ended_event
tags:
  - Audio
  - Event
  - HTML DOM
  - HTMLMediaElement
  - Media
  - Media Streams API
  - Reference
  - Video
  - Web Audio API
  - ended
---
<p>{{DefaultAPISidebar("Web Audio API")}}</p>

<p>The <code>ended</code> event of the {{domxref("AudioScheduledSourceNode")}} interface is fired when the source node has stopped playing.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Bubbles</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Cancelable</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Interface</th>
   <td>{{domxref("Event")}}</td>
  </tr>
  <tr>
   <th scope="row">Event handler property</th>
   <td>{{domxref("AudioScheduledSourceNode.onended")}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Usage_notes">Usage notes</h2>

<p>This event occurs when a {{domxref("AudioScheduledSourceNode")}} has stopped playing, either because it's reached a predetermined stop time, the full duration of the audio has been performed, or because the entire buffer has been played.</p>

<h2 id="Examples">Examples</h2>

<p>In this simple example, an event listener for the <code>ended</code> event is set up to enable a "Start" button in the user interface when the node stops playing:</p>

<pre class="brush: js notranslate">node.addEventListener('ended', () =&gt; {
  document.getElementById("startButton").disabled = false;
})</pre>

<p>You can also set up the event handler using the {{domxref("AudioScheduledSourceNode.onended")}} property:</p>

<pre class="brush: js notranslate">node.onended = function() {
  document.getElementById("startButton").disabled = false;
}</pre>

<p>For an example of the ended event in use, see our <a href="https://mdn.github.io/webaudio-examples/audio-buffer/">audio-buffer example on GitHub</a>.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{ SpecName('Web Audio API', '#dom-audioscheduledsourcenode-onended', 'onended') }}</td>
   <td>{{ Spec2('Web Audio API') }}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.AudioScheduledSourceNode.ended_event")}}</p>

<h2 id="Related_events">Related events</h2>

<ul>
 <li class="zhc-markdown-block--checklist-item"><span><span class="zhc-markdown-block--checklist-item--remaining-text"><span class="zhc-markdown-block zhc-markdown-block--html"><a href="/en-US/docs/Web/Events/audioprocess">audioprocess</a></span></span></span></li>
 <li class="zhc-markdown-block--checklist-item"><span><span class="zhc-markdown-block--checklist-item--remaining-text"><span class="zhc-markdown-block zhc-markdown-block--html"><a href="/en-US/docs/Web/Events/complete">complete</a></span></span></span></li>
</ul>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("HTMLAudioElement")}}</li>
 <li>{{domxref("HTMLVideoElement")}}</li>
 <li>{{HTMLElement("audio")}}</li>
 <li>{{HTMLElement("video")}}</li>
 <li>{{domxref("HTMLMediaElement.ended_event", 'HTMLMediaElement: ended event')}}</li>
 <li>{{domxref("MediaStreamTrack.ended_event", 'MediaStreamTrack: ended event')}}</li>
</ul>
